/**
 * Reflect section of the Underground Cave.
 * @param {UndergroundCaveController} controller The Underground Cave controller.
 */
function UndergroundCaveReflectionDominance(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = UndergroundCaveReflectionSucceedChoice.DOMINATE;
    var reqController = ctrl.reflectSucceed;
    var subController = ctrl.reflectDominance;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new UndergroundCaveReflectionOral(ctrl);
    var secondNext = new UndergroundCaveReflectionSex(ctrl);
    var thirdNext = new UndergroundCaveReflectionGetFucked(ctrl);

    var firstChoice = UndergroundCaveReflectionDominanceChoice.ORAL;
    var secondChoice = UndergroundCaveReflectionDominanceChoice.SEX;
    var thirdChoice = UndergroundCaveReflectionDominanceChoice.SUB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.well.basiliskDominated = true;
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            The basilisk is already beaten.
                            There is no point to taking its life, or turning it into an ornament for that matter.
                            It has submitted to you.
                            You could just leave, but seeing the creature on its back brings some [i]unsavory[/i] thoughts to mind.
                        [/p]
                        [p]
                            You study the creature, going around it with the mirror-shard at the ready, in case it suddenly decides to fight back.
                            As your sight wanders over the crocodillian's underside, you become aware of its hard,
                            throbbing, fully erect draconic-looking member jutting out from its nethers, standing at attention like the mast of a large and scaly ship.
                            The beast isn't even trying to hide its arousal.
                            It must be in rut or something.
                            Maybe that's why it was so fiercely defending its lair.
                            Perhaps you've inadvertently taken part of some sort of a basilisk mating ritual.
                            Maybe you've even asserted yourself as the [b]dominant[/b] partner, by petrifying the monster.
                        [/p]
                        [p]
                            Lying there, panting slightly, with its cock brimming with lust, the once-terrifying feral almost looks [i]cute[/i].
                            Like a perfectly tamed and loyal pet, waiting for a [i]treat[/i].
                            The longer you look at it, the more often your eyes find their way back to its member.
                            While you were already planning on sating your lust on the basilisk,
                            its shameless display has cemented your desire.
                            ${dick ? `Your length hardens within your slit, the tapered tip peeking out already.` : `Your slit moistens in anticipation.`}
                        [/p]
                        [p]
                            The basilisk wants to mate.
                            Who are you to deny it?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Use its muzzle</button>`;

        var tooltip = global.parser.parse(`Time to facefuck a beast's mouth filled with sharp teeth. What could go wrong?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Fuck it</button>`;

        var male = ctrl.misc.dick();
        var tooltip = global.parser.parse(`Make the basilisk your [b]bitch[/b].`);
        if (!male) {
            tooltip = global.parser.parse(`Fingerfuck the basilisk's tailhole. Make it your [b]bitch[/b].`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Ride it</button>`;

        var tooltip = global.parser.parse(`The beast's erect member allures you. You wonder how it would feel inside of you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var UndergroundCaveReflectionDominanceChoice = {
    ORAL: 1,
    SEX: 2,
    SUB: 3
};
