/**
 * Proposition section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeFemaleInside(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = MorningThreeFemaleSexChoice.INSIDE;
    var reqController = ctrl.femaleSex;
    var subController = ctrl.preBucket;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new MorningThreeBucket(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.morning.cameInside = true;
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = `[p]
                            A million thoughts flash through your mind, the most pressing one being that you could very well end up pregnant if you let him finish inside.
                            You're not sure if you're ready to be a mother yet.
                            But at least, even if you [b]do[/b] get pregnant, it'll be the child of someone you like, and may even grow to [b]love[/b].
                            He stops his thrusting, impatiently awaiting an answer.
                            Wrapping your legs around his body, you pull him closer to you, locking him inside of your sopping wet folds.
                            You nod at him.
                            You are ready.
                        [/p]
                        [p]
                            A look of pure bliss takes over the cyan kobold's face.
                            He happily obliges, starting to hump you like [b]crazy[/b],
                            fucking you with renewed vigor and zeal, holding you close while [b]pounding[/b] you like there's no tomorrow.
                            You forego riding him, instead just sitting still, letting him have his way with you, letting him [b]fuck[/b] you to climax.
                        [/p]
                        [p]
                            It doesn't take much more for you to reach your end.
                            Your moans get louder and louder, ultimately culminating into a [b]scream[/b] of pleasure, a mind-wracking orgasm hitting your body hard.
                            Your feminine fluids [b]squirt[/b] all over his abdomen, while your innards quiver and spasm,
                            tightening around the kobold's cock, massaging its entire length, [b]milking[/b] it for its fertile semen.
                            The sensation proves to be too much for your partner.
                            After giving you a few more aggressive thrusts, he keeps himself hilted, his shaft [b]pulsing[/b] as he cums inside of you,
                            wave after wave of warm, fertile semen pumped directly into the depths of your cunt.
                        [/p]
                        [p]
                            As his orgasm begins to fade, the cyan kobold slowly pulls out of your cum-leaking slit.
                            You have no idea whether or not he got you pregnant, but part of you [b]hopes[/b] that he did.
                            His bountiful spunk oozes from your thoroughly bred groin, dripping down to the ground below,
                            mixing with the small puddle of your arousal that formed during the intense bout of lovemaking.
                        [/p]
                        [p]
                            Your partner lowers you to the ground.
                            The two of you stare longingly into one another's eyes, wordlessly connecting on a spiritual level.
                            Time seems to stop.
                            You wish you could stay like this forever.
                            But alas, your tranquil moment gets interrupted all too soon.
                        [/p]`;

        if (virgin) {
            toReturn += `[p]
                            [c]
                                [b]
                                    You are no longer a virgin.
                                [/b]
                            [/c]
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.femaleInside.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
